﻿@{
    ViewData["Title"] = "Firm Principal List";
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="tab-content">
                <div id="firm-principal-list">
                    <div class="d-flex flex-row-reverse">
                        <div>
                            <button class="btn btn-primary btn-admin-add btn-add"><i class="fas fa-plus"></i>New Principal</button>
                        </div>
                        <div class="mr-5">
                            <button onclick="$('#FirmPrincipalAdvanceFilterModal').modal({ backdrop: 'static' });" class="btn btn-outline-dark btn-hover-light-dark" id="btn-advance-filter" style="padding: 9.5px 15px;" data-toggle="tooltip" title="Click here to Advance Search"><i class="fas fa-filter p-0"></i></button>
                        </div>
                    </div>
                    <div class="datatable datatable-bordered" id="firm_list"></div>
                </div>
                <div id="filtered-firm-principal-list" class="d-none">
                    <button onclick="toggleDiv();window['datatable'].reload();" class="btn btn-sm btn-icon btn-outline-primary btn-hover-light-primary btn-circle" data-toggle="tooltip" title="Back to Default View" id="btn-nav-back">
                        <i class="fas fa-arrow-left"></i>
                    </button>
                    <div class="datatable datatable-bordered" id="firmprincipal-list"></div>
                </div>
            </div>
        </div>
    </div>
</div>
<div class="modal" id="FirmPrincipalModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<div class="modal" id="FirmPrincipalAdvanceFilterModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog max-w-550px" role="document">
        <div class="modal-content">
            <form id="advance-filter-frm">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Advance Filter</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <i aria-hidden="true" class="ki ki-close"></i>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>Firm Name</label>
                        <select placeholder="Firm Name" name="FirmId" id="FirmId-Filter" class="form-control form-control-lg select2-control select2 required" data-allow-clear="true" style="width:100%" data-placeholder="-Select-"></select>
                    </div>
                    <div class="row">
                        <div class="col-md-3">
                            <div class="form-group">
                                <label>User Id</label>
                                <input class="form-control form-control-lg numericOnly-no-placeholder" placeholder="User Id" maxlength="5" name="Id" id="Id">
                            </div>
                        </div>
                        <div class="col-md-9">
                            <div class="form-group">
                                <label>Principal Name</label>
                                <input class="form-control form-control-lg" placeholder="Principal Name" name="AdviserName" id="AdviserName">
                            </div>
                        </div>
                    </div>
                    <div class="form-group mb-0 permission-select2-container">
                        <label>Roles</label>
                        <select id="Roles" name="Roles" class="form-control form-control-lg select2" asp-items="ViewBag.PermissionTypes" data-placeholder="Select Permissions" style="width:100%" multiple="multiple"></select>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-primary font-weight-bold" id="btn-advance-filter-submit"><i class="fas fa-search"></i>Search</button>
                </div>
            </form>
        </div>
    </div>
</div>
@section scripts{
    <script>
        var principalTable = function (e) {
            var id = e.data.id;
            var ktDataTablOptions = ktDataTableDefaultConfigOptions;
            ktDataTablOptions.source = `admin/superadmin/fetchadmins?role=${AdminRoleEnum.FIRMPRINCIPAL}&FirmId=${id}`;
            window['sub_datatable_' + id] = $('<div/>').attr('id', `firm_list_${id}`).appendTo(e.detailCell).KTDatatable({
                data: ktDataTablOptions,
                columnFilter: true,
                columns: [
                    { field: 'id', title: '#', width: 85, filter: { maxlength: 5, additionalClasses: "numericOnly-no-placeholder" } },
                    {
                        field: 'userData.name', sortable: 'asc', title: 'Name/Email', width: 330, filter: { container: "AdviserName" },
                        template: function (row) {
                            var isValidDate = row.setupCompletedDate != null && row.setupCompletedDate.length > 2;
                            var initial = [row.userData.firstName, row.userData.lastName].map((n) => n[0]).join("").substring(0, 2);
                            var color = getRandomColor();
                            var warningHtml = !isValidDate ?
                                `<span class="fa-stack pulse pulse-warning ml-2" data-toggle="tooltip" data-html="true" data-original-title="Complete the Password setup process" data-placement="right" role = "button" >
                                                 <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                 <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                 <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                             </span>` : '';
                            return `<div class="d-flex align-items-center">
                                                     <div class="symbol symbol-40 flex-shrink-0">
                                                          <div class="symbol-label text-white" style="background:${color}">${initial}</div>
                                                     </div>
                                                     <div class="ml-2">
                                                         <div class="text-dark-75 font-weight-bold line-height-sm">${row.userData.name}</div>
                                                         <div class="text-primary">${row.username}</div>
                                                     </div>
                                                     ${warningHtml}
                                                 </div>`;
                        },
                    },
                    {
                        field: 'roles', title: 'Roles', sortable: false, width: 190, filter: { filterType: "multiselect", additionalClasses: `roles-filter-dropdown-${id}` },
                        template: function (row) {
                            var label_class = "";
                            label_class = row.adminRole == AdminRoleEnum.FIRMPRINCIPAL ? "dark" : row.adminRole == AdminRoleEnum.FIRMADMIN ? "warning" : row.adminRole == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                            var html = `<span class="label label-outline-${label_class} label-inline mr-2 mb-2 font-weight-bold">${row.adminRoleString}</span>`;
                            row.permissions.forEach(function (item) {
                                label_class = item.roleType == AdminRoleEnum.FIRMADMIN ? "warning" : item.roleType == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                                html += `<span class="label label-${label_class} label-inline mr-2 mb-2">${item.roleTypeString}</span>`;
                            })
                            return html;
                        }
                    },
                    {
                        field: 'setupCompletedDate', title: 'Password&nbsp;Setup', sortable: false, width: 125,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.setupCompletedDate)
                        },
                    },
                    {
                        field: 'lastLogin', title: 'Last Login', sortable: false, width: 80,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.lastLogin)
                        }
                    },
                    {
                        field: 'actions', title: 'Actions', width: 100, sortable: false, overflow: 'visible',
                        template: function (row) {
                            var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                            var resend_html = !isSetupCompleted ?
                                `<button class="btn btn-sm btn-icon resend-invitation-button" data-toggle="tooltip" data-original-title="Resend Invitation" onclick="reinvite(this,${AdminRoleEnum.FIRMPRINCIPAL},'${row.guid}')">
                                                                                            <img src="/images/email-resend-icon.png" height="25" />
                                                                                            <i class="fa fa-redo text-warning icon-sm resend-invitation-icon" aria-hidden="true" style="left: 69px;top: 29px;"></i>
                                                                                        </button>`: "";
                            return `<button class="btn btn-sm btn-admin-add" data-toggle="tooltip" data-original-title="Edit" data-guid="${row.guid}">
                                                                              <img src="/images/edit-icon.png" height="25" />
                                                                        </button>
                                                                        ${resend_html}
                                                                        <button class="btn btn-sm btn-icon d-none" data-toggle="tooltip" data-original-title="Delete">
                                                                               <img src="/images/delete-icon.png" height="25" />
                                                                        </button>`;
                        },
                    }
                ],
            })
            $(`#firm_list_${id}`).on('datatable-on-init', function (e, data) {
                bindRolesDropdown(id);
            });
        }

        bindFirmsGrid('FirmPrincipal', principalTable);

        $(document).on("click", ".btn-admin-add", function () {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`admin/firmprincipal/addfirmprincipal?guid=${guid}`, "FirmPrincipalModal", null, function () {
                KTApp.unblockPage();
                bindFirmDropdown();
                bindPermissionMultiselect2();
                $("#FirmPrincipalModal").modal({ backdrop: 'static' });
            });
        });

        $(document).on("click", "#btn-advance-filter-submit", function () {
            if (!$("#FirmId-Filter").val() && !$("#Id").val() && !$("#AdviserName").val() && !$("#Roles").val().toString()) {
                _showFormMessage("advance-filter-frm", "danger", "Please insert at least one search criteria", "fas fa-exclamation-triangle");
                return;
            }
            $(".alert").remove();
            advanceSearch();
            $(`#FirmPrincipalAdvanceFilterModal`).modal('hide');
            $("#btn-nav-back").removeClass("d-none");
            $(".nav-item .nav-link").eq(1).click();
        });
        var bindAdvanceSearchFirmPrincipalList = function () {
            if ($('#firmprincipal-list').html() != '')
                window['datatable-firm-principal-list'].destroy();
            var ktDataTablOptions2 = ktDataTableDefaultConfigOptions;
            var roles = $("#Roles").val().toString();
            ktDataTablOptions2.source = {
                read: {
                    url: `admin/superadmin/fetchadmins?role=${AdminRoleEnum.FIRMPRINCIPAL}`,
                    params: {
                        query:
                        {
                            FirmId: $("#FirmId-Filter").val(),
                            Id: $("#Id").val(),
                            AdviserName: $("#AdviserName").val(),
                            Roles: roles ? roles : AdminRoleEnum.FIRMPRINCIPAL.toString()
                        }
                    }
                }
            };

            window['datatable-firm-principal-list'] = $('#firmprincipal-list').KTDatatable({
                data: ktDataTablOptions2,
                columns: [
                    { field: 'id', title: '#', width: 30 },
                    {
                        field: 'userData.name', title: 'Name', sortable: 'asc', width: 330,
                        template: function (row) {
                            var isValidDate = row.setupCompletedDate != null && row.setupCompletedDate.length > 2;
                            var initial = [row.userData.firstName, row.userData.lastName].map((n) => n[0]).join("").substring(0, 2);
                            var color = getRandomColor();
                            var warningHtml = !isValidDate ?
                                `<span class="fa-stack pulse pulse-warning ml-2" data-toggle="tooltip" data-html="true" data-original-title="Complete the Password setup process" data-placement="right" role = "button" >
                                                 <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                 <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                 <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                             </span>` : '';
                            return `<div class="d-flex align-items-center">
                                                     <div class="symbol symbol-40 flex-shrink-0">
                                                          <div class="symbol-label text-white" style="background:${color}">${initial}</div>
                                                     </div>
                                                     <div class="ml-2">
                                                         <div class="text-dark-75 font-weight-bold line-height-sm">${row.userData.name}</div>
                                                         <div class="text-primary">${row.username}</div>
                                                     </div>
                                                     ${warningHtml}
                                                 </div>`;
                        },
                    },
                    {
                        field: 'firm.name', title: 'Firm Name', width: 125
                    },
                    {
                        field: 'roles', title: 'Roles', sortable: false, width: 190,
                        template: function (row) {
                            var label_class = "";
                            label_class = row.adminRole == AdminRoleEnum.FIRMPRINCIPAL ? "dark" : row.adminRole == AdminRoleEnum.FIRMADMIN ? "warning" : row.adminRole == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                            var html = `<span class="label label-outline-${label_class} label-inline mr-2 mb-2 font-weight-bold">${row.adminRoleString}</span>`;
                            row.permissions.forEach(function (item) {
                                label_class = item.roleType == AdminRoleEnum.FIRMADMIN ? "warning" : item.roleType == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                                html += `<span class="label label-${label_class} label-inline mr-2 mb-2">${item.roleTypeString}</span>`;
                            })
                            return html;
                        }
                    },
                    {
                        field: 'setupCompletedDate', title: 'Password&nbsp;Setup', sortable: false, width: 125,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.setupCompletedDate)
                        },
                    },
                    {
                        field: 'lastLogin', title: 'Last Login', sortable: false, width: 80,
                        template: function (row) {
                            return getDataTableDateWithHtml(row.lastLogin)
                        }
                    },
                    {
                        field: 'actions', title: 'Actions', width: 100, sortable: false, overflow: 'visible',
                        template: function (row) {
                            var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                            var resend_html = !isSetupCompleted ?
                                `<button class="btn btn-sm btn-icon resend-invitation-button" data-toggle="tooltip" data-original-title="Resend Invitation" onclick="reinvite(this,${AdminRoleEnum.FIRMPRINCIPAL},'${row.guid}')">
                                                                                            <img src="/images/email-resend-icon.png" height="25" />
                                                                                            <i class="fa fa-redo text-warning icon-sm resend-invitation-icon" aria-hidden="true" style="left: 69px;top: 29px;"></i>
                                                                                        </button>`: "";
                            return `<button class="btn btn-sm btn-admin-add" data-toggle="tooltip" data-original-title="Edit" data-guid="${row.guid}">
                                                                              <img src="/images/edit-icon.png" height="25" />
                                                                        </button>
                                                                        ${resend_html}
                                                                        <button class="btn btn-sm btn-icon d-none" data-toggle="tooltip" data-original-title="Delete">
                                                                               <img src="/images/delete-icon.png" height="25" />
                                                                        </button>`;
                        },
                    }
                ],
            })
        }

        var advanceSearch = function () {
            toggleDiv();
            bindAdvanceSearchFirmPrincipalList();
        }

        var toggleDiv = function () {
            $("#firm-principal-list").toggleClass("d-none");
            $("#filtered-firm-principal-list").toggleClass("d-none");
        }

        $('#FirmPrincipalAdvanceFilterModal').on('hidden.bs.modal', function (e) {
            $(e.currentTarget).find("input").val("");
            $(e.currentTarget).find("select").val("").trigger("change");
        });
        bindFirmDropdown("FirmId-Filter");
        bindPermissionMultiselect2("Roles");
    </script>
}